#!/usr/bin/python

import lxml.etree

doc = lxml.etree.parse(open('example.xml')) 

# single slash selects from the root node. 
#you can select bookstore this way
print "Bookstore locations"
for bookstore in doc.xpath('/bookstore'):
  print bookstore.get('location') 
print

#but not book (since book is not a direct child of the root node)
print "Book categories"
for book in doc.xpath('/book'):
  print book.get('category')
print

# double slash (//) selects nodes from the current node, anywhere in the tree
# So you can select all the books, even though they are not direct children of the parent
print "Book categories"
for book in doc.xpath('//book'):
  print book.get('category') 
print

# Or all the dvds
print "DVD categories"
for book in doc.xpath('//dvd'):
  print book.get('category') 
print

#Or you can select all titles, regardless of whether they are books or dvds
print "All titles"
for title in doc.xpath('//title'):
  print '%s available in language %s'%(title.text, title.get('lang'))
print

#You can combined to create longer paths, e.g. to only select title nodes that appear as children of dvd nodes
print "Only DVD titles"
for title in doc.xpath('//dvd//title'):
  print '%s available in language %s'%(title.text, title.get('lang'))
print

